package com.kakao.sdk.common

import okhttp3.Interceptor
import okhttp3.Response

/**
 * @author kevin.kang. Created on 2018. 3. 22..
 */
class AppKeyInterceptor(private val appKey: String = KakaoSdk.applicationContextInfo.clientId) :
    Interceptor {
    override fun intercept(chain: Interceptor.Chain): Response {
        var request = chain.request()
        request = request.newBuilder()
            .addHeader(Constants.AUTHORIZATION, "KakaoAK $appKey")
            .build()
        return chain.proceed(request)
    }
}