@file:JvmName("SdkLoggerKt")

package com.kakao.sdk.network

import com.kakao.sdk.common.*
import io.reactivex.subjects.PublishSubject

/**
 * @author kevin.kang. Created on 2019-10-16..
 */
class RxSdkLogger : SdkLogger() {

    private val subject = PublishSubject.create<Any>()
    val observable = subject.hide()

    /**
     * @suppress
     */
    override fun log(logged: Any, logLevel: LogLevel) {
        val loggedObject = "${logLevel.symbol} $logged"
        if (BuildConfig.DEBUG) {
            if (logLevel.level >= debugLogLevel.level) {
                subject.onNext(loggedObject)
            }
            return
        }
        if (KakaoSdk.loggingEnabled && logLevel.level >= releaseLogLevel.level) {
            subject.onNext(loggedObject)
        }
    }

    companion object {
        @JvmStatic
        val instance by lazy { SdkLogger.rx }
    }
}

val SdkLogger.Companion.rx by lazy { RxSdkLogger() }